/* Bard's Tale Character Editor */
#include "tpw.h"
#include "char.h"
#include "party.h"
#include "btce.h"
#include "rename.h"
#include "edit.h"
#include "tpwdump.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BTCE_VERSION "1.4"
#define BTCE_YEAR 2019

int main(int argc, char **argv) {
FILE * fpin;
struct TPW tpw;
struct PARTY party;
struct BARDCHAR bard;
int farg;
char buffer[256];
int i;
int newname=0, edit=1, newchar=0, csv=0, dump=0;
int gethelp=0;

if (argc<2) gethelp=1;
farg = argc-1;
if (argc>1) {
if (strcmp(argv[1],"/C")==0) csv=1;
if (strcmp(argv[1],"/c")==0) csv=1;
if (strcmp(argv[1],"-C")==0) csv=1;
if (strcmp(argv[1],"-c")==0) csv=1;
if (strcmp(argv[1],"/H")==0) gethelp=1;
if (strcmp(argv[1],"/h")==0) gethelp=1;
if (strcmp(argv[1],"-H")==0) gethelp=1;
if (strcmp(argv[1],"-h")==0) gethelp=1;
if (strcmp(argv[1],"/?")==0) gethelp=1;
if (strcmp(argv[1],"-?")==0) gethelp=1;
}
if (argc>2) {
if (strcmp(argv[1],"/D")==0) dump=1;
if (strcmp(argv[1],"/d")==0) dump=1;
if (strcmp(argv[1],"-D")==0) dump=1;
if (strcmp(argv[1],"-d")==0) dump=1;
if (strcmp(argv[1],"/R")==0) newname=1;
if (strcmp(argv[1],"/r")==0) newname=1;
if (strcmp(argv[1],"-R")==0) newname=1;
if (strcmp(argv[1],"-r")==0) newname=1;
if (strcmp(argv[1],"/E")==0) edit=1;
if (strcmp(argv[1],"/e")==0) edit=1;
if (strcmp(argv[1],"-E")==0) edit=1;
if (strcmp(argv[1],"-e")==0) edit=1;
if (strcmp(argv[1],"/P")==0) edit=0;
if (strcmp(argv[1],"/p")==0) edit=0;
if (strcmp(argv[1],"-P")==0) edit=0;
if (strcmp(argv[1],"-p")==0) edit=0;
if (strcmp(argv[1],"/N")==0) newchar=1;
if (strcmp(argv[1],"/n")==0) newchar=1;
if (strcmp(argv[1],"-N")==0) newchar=1;
if (strcmp(argv[1],"-n")==0) newchar=1;
}

if (gethelp) return help();
if (csv) return tpwdump(argc, argv[farg], 1);
if (dump) return tpwdump(argc, argv[farg], 0);
printf("Chappell\'s Bard\'s Tale Character Editor Version %s\n", 
    BTCE_VERSION);
if (newname) return renameChar(argv[farg]);
if (newchar) return editCharacter(argv[farg],0);
if (edit) return editCharacter(argv[farg],1);
    
if (fpin = fopen(argv[farg],"rb")) {
  if (fgetTPW(&tpw, fpin)) {
    if (isparty(tpw)) {
      if (getparty(&party,fpin)) {
        printf("\nFile: %s\nParty Name: %s", argv[farg], tpw.name);
        printf("\nParty members are:");
    dumpparty(&party);
      } else { /* get party */
    printf("\nParty read failed!\n");
    return EXIT_FAILURE;
      } /* get party */
    } else { /* is party ? */
      printf("\nFile: %s\nCharacter Name: %s", argv[farg], tpw.name);
      fgetBardCharacter(&bard, fpin);
      dumpcharacter(&bard);
    } /* is party ? */
  } else { /* read tpw */
    printf("\nTPW read failed!\n");
    return EXIT_FAILURE;
  } /* read tpw */
  return EXIT_SUCCESS;
} else { /* read file */
  printf("\nUnable to read %s!", argv[farg]);
  return EXIT_FAILURE;
} /* read file */
} /* main */

int help(void) {
printf("Chappell\'s Bard\'s Tale Character Editor Version %s", 
    BTCE_VERSION);
printf(
"\nusage: btce [-c][-d][-e][-h][-n][-p][-r] tpwfile\n"); 
printf(
"\n -c  Csv dump"); 
printf(
"\n -d  Short dump"); 
printf(
"\n -e  Edit (default)"); 
printf(
"\n -h  Help"); 
printf(
"\n -n  Create new character"); 
printf(
"\n -p  Print character"); 
printf(
"\n -r  Rename character"); 
printf(
"\n"); 
printf(
"\nOption flags can begin with \'-\' or '/', and can be uppercase or"); 
printf(
"\nlowercase."); 
printf(
"\nThe main menu will accept lines starting with [\'[;:!#%(@] as comments."); 
printf(
"\nThis will allow commenting input files. (Only the main menu)"); 
printf("\n"); 
printf(
"\nThis program is released \"as is\", with no warranty.  Use at your own risk."
); 
printf(
"\nYou may distribute this program freely provided:"); 
printf(
"\n * You provide the source with it."); 
printf(
"\n * You do not charge for this software."); 
printf(
"\n * You acknowledge the author if modifying the source."); 
printf("\nCopyright %d Michael J. Chappell\n", BTCE_YEAR);
return 0;
} /* help */
